--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--  Modify the combatControl variable if you don't want the Tooltip hiding during combat.
--  Default value is combatControl=true and tooltip hides during combat for the WorldFrame.
--  Set combatControl=false to prevent the tooltip from hiding during combat.
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
local combatControl = true
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
hooksecurefunc( "GameTooltip_SetDefaultAnchor", function( self, parent )
	local x = GetMouseFocus()
	if ( x == ChatFrame1 ) or ( x == ChatFrame1EditBox ) or ( x == ChatFrame2 ) or ( x == ChatFrame2EditBox ) or ( x == ChatFrame3 ) or ( x == ChatFrame3EditBox ) or ( x == ChatFrame4 ) or ( x == ChatFrame4EditBox ) or ( x == ChatFrame5 ) or ( x == ChatFrame5EditBox ) or ( x == ChatFrame6 ) or ( x == ChatFrame6EditBox ) or ( x == ChatFrame7 ) or ( x == ChatFrame7EditBox ) or ( x == ChatFrame8 ) or ( x == ChatFrame8EditBox ) or ( x == ChatFrame9 ) or ( x == ChatFrame9EditBox ) or ( x == ChatFrame10 ) or ( x == ChatFrame10EditBox ) then
		return
	elseif AuctionFrame and AuctionFrame:IsShown() then
		return
	else
		if ( x == WorldFrame ) then
			self:ClearAllPoints()
			self:SetOwner( parent, "ANCHOR_CURSOR" )
		else
			self:ClearAllPoints()
			self:SetOwner( parent, "ANCHOR_TOP", 0, 10 )
		end
	end
end )
hooksecurefunc( GameTooltip, "SetUnitAura", function( self, unit, index, filter )
	local _, _, _, _, _, _, unitCaster = UnitAura( unit, index, filter )
	local name = unitCaster and UnitName( unitCaster )
	if name and ( name ~= GetUnitName( "player" ) ) then
		self:AddDoubleLine( "Casted by:", name, nil, nil, nil, 1, 1, 1 )
		self:Show()
	end
end )
GameTooltip:HookScript( "OnTooltipSetUnit", function( self )
	if combatControl and InCombatLockdown() then
		local unit = select( 2, self:GetUnit() )
		if unit then
			local guid = UnitGUID( unit )
			if guid then
				local type, _, _, _, _, npcID = strsplit( "-", guid )
				if ( type ~= "Player" ) and ( type ~= "Vignette" ) then
					npcID = tonumber( npcID )
					local t = { 131616, 134064, 139573, 144605, 147834, 147876, 147861, 147774, 147775, 147780, 147784, 155909, 155910, 155911 }
					for i = 1, #t do
						if ( npcID == t[i] ) then
							return
						end
					end
				elseif ( type == "Player" ) then
					for i = 1, 40 do
						local _, _, _, _, _, _, _, _, _, spellID = UnitAura( unit, i, "HARMFUL" )
						if not spellID then
							break
						elseif ( spellID == 286105 ) then
							return
						end
					end
				end
			end
		end
		GameTooltip:Hide()
	end
end )